package com.psmreborn.shared;

import android.util.Log;

public class Logger {
    private static final char[] HEX_ARRAY = "0123456789ABCDEF".toCharArray();
    private static String bytesToHex(byte[] bytes) {
        if(bytes == null) return "(nulL)";
        char[] hexChars = new char[bytes.length * 2];
        for (int j = 0; j < bytes.length; j++) {
            int v = bytes[j] & 0xFF;
            hexChars[j * 2] = HEX_ARRAY[v >>> 4];
            hexChars[j * 2 + 1] = HEX_ARRAY[v & 0x0F];
        }
        return new String(hexChars);
    }
    public static void logText(String description, String text){
        Log.i("NoPsmDrmApp", description + " = "+text);
    }
    public static void logBytes(String description, byte[] data){
        Log.i("NoPsmDrmApp", description + " = " + bytesToHex(data));
    }

}
